/*
 * Copyright 2014 CyberVision, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kaaproject.kaa.demo.playerdemo.data;

import org.kaaproject.kaa.demo.player.DeviceInfo;

public class DeviceInfoEntry {
    
    String endpointKey;
    DeviceInfo deviceInfo;
    
    public DeviceInfoEntry(String endpointKey, DeviceInfo deviceInfo) {
        this.endpointKey = endpointKey;
        this.deviceInfo = deviceInfo;
    }

    public String getEndpointKey() {
        return endpointKey;
    }

    public void setEndpointKey(String endpointKey) {
        this.endpointKey = endpointKey;
    }

    public DeviceInfo getDeviceInfo() {
        return deviceInfo;
    }

    public void setDeviceInfo(DeviceInfo deviceInfo) {
        this.deviceInfo = deviceInfo;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((endpointKey == null) ? 0 : endpointKey.hashCode());
        result = prime * result
                + ((deviceInfo == null) ? 0 : deviceInfo.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        DeviceInfoEntry other = (DeviceInfoEntry) obj;
        if (endpointKey == null) {
            if (other.endpointKey != null)
                return false;
        } else if (!endpointKey.equals(other.endpointKey))
            return false;
        if (deviceInfo == null) {
            if (other.deviceInfo != null)
                return false;
        } else if (!deviceInfo.equals(other.deviceInfo))
            return false;
        return true;
    }
    
    
}
